config/routes.rb
Rails.application.routes.draw do
  resources :har_files do
    resources :requests, only: [:index]
    get '/requests/:index', to: 'requests#show', as: 'request_by_index'
  end
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/har_file.rb
# Model for har file
class HarFile < ApplicationRecord
  mount_uploader :content, ContentUploader
  validates :name, presence: true, length: { in: 2..20 }
  has_many :requests, dependent: :destroy, validate: true
  validate :requests_required

  def requests_required
    errors.add :requests, 'A HAR file should have at least one request entry' if requests.blank?
  end
end

app/models/request.rb
# Model for request within har file
class Request < ApplicationRecord
  belongs_to :har_file
  validates :method, presence: true,
                     inclusion: {
                       in: %w(HEAD GET POST PUT DELETE OPTIONS PATCH CONNECT),
                       message: 'Method for request must be present and be a valid method'
                     }
  validates :uri, presence: { message: 'URL for request must be present' }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/har_files_controller.rb
class HarFilesController < ApplicationController
  skip_before_action :verify_authenticity_token
  before_action :set_har_file, only: %i[show edit update destroy]

  # GET /har_files
  # GET /har_files.json
  def index
    @har_files = HarFile.all
  end

  # GET /har_files/1
  # GET /har_files/1.json
  def show
  end

  # GET /har_files/new
  def new
    @har_file = HarFile.new
  end

  # GET /har_files/1/edit
  def edit
  end

  # POST /har_files
  # POST /har_files.json
  def create
    @har_file = HarFile.new(har_file_params)
    @har_file.requests << process_file(@har_file.content.current_path)
    respond_to do |format|
      if @har_file.save
        format.html { redirect_to @har_file, notice: 'Har file was successfully created.' }
        format.json { render :show, status: :created, location: @har_file }
      else
        format.html { render :new }
        format.json { render json: @har_file.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /har_files/1
  # PATCH/PUT /har_files/1.json
  def update
    @har_file.requests << process_file(har_file_params[:content].path)
    respond_to do |format|
      if @har_file.update(har_file_params)
        format.html { redirect_to @har_file, notice: 'Har file was successfully updated.' }
        format.json { render :show, status: :ok, location: @har_file }
      else
        format.html { render :edit }
        format.json { render json: @har_file.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /har_files/1
  # DELETE /har_files/1.json
  def destroy
    @har_file.destroy
    respond_to do |format|
      format.html { redirect_to har_files_url, notice: 'Har file was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_har_file
      @har_file = HarFile.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def har_file_params
      params.require(:har_file).permit(:name, :description, :content)
    end

    # Below private methods process the file and extract requests.
    # TODO consider moving logic to a callback on har_file
    def process_file(file)
      if file.blank?
        logger.debug('The content uploader has deemed this file unfit')
        return []
      end
      json = parse_content(file)
      log = json[:log]
      if log.blank?
        logger.debug("file does not contain a 'log' object")
        return []
      end
      entries = log[:entries]
      if entries.blank?
        logger.debug('har file does not contain any entries/requests')
        return []
      end
      # TODO: Expand validation of all fields in file
      generate_requests(entries)
    end

    def parse_content(path)
      content = File.read(path)
      JSON.parse(content, symbolize_names: true)
    end

    def generate_requests(entries)
      requests = []
      entries.each_with_index do |entry, index|
        request_json = entry[:request]
        request = Request.new(method: request_json[:method], uri: request_json[:url], index: index)
        requests << request
      end
      requests
    end
end

app/controllers/requests_controller.rb
class RequestsController < ApplicationController
  before_action :set_request, only: [:show, :edit, :update, :destroy]

  # GET /requests
  # GET /requests.json
  def index
    @har_file_id = params.require(:har_file_id)
    @requests = Request.where(har_file_id: @har_file_id)
  end

  # GET /requests/1
  # GET /requests/1.json
  def show
  end

  # GET /requests/new
  def new
    @request = Request.new
  end

  # GET /requests/1/edit
  def edit
  end

  # POST /requests
  # POST /requests.json
  def create
    @request = Request.new(request_params)

    respond_to do |format|
      if @request.save
        format.html { redirect_to @request, notice: 'Request was successfully created.' }
        format.json { render :show, status: :created, location: @request }
      else
        format.html { render :new }
        format.json { render json: @request.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /requests/1
  # PATCH/PUT /requests/1.json
  def update
    respond_to do |format|
      if @request.update(request_params)
        format.html { redirect_to @request, notice: 'Request was successfully updated.' }
        format.json { render :show, status: :ok, location: @request }
      else
        format.html { render :edit }
        format.json { render json: @request.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /requests/1
  # DELETE /requests/1.json
  def destroy
    @request.destroy
    respond_to do |format|
      format.html { redirect_to requests_url, notice: 'Request was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_request
      @request = Request.where(index: params[:index],
                               har_file_id: params[:har_file_id]).first
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def request_params
      params.require(:request).permit(:index, :method, :uri, :har_file_id)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/har_files_helper.rb
# Helper methods to extract out shared processing logic between controller/view
module HarFilesHelper
  def retrieve_file_content(path)
    content = File.read(path)
    JSON.parse(content)
  end
end

app/views/har_files/_form.html.erb
<%= form_with(model: har_file, local: true) do |form| %>
  <% if har_file.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(har_file.errors.count, "error") %> prohibited this har_file from being saved:</h2>

      <ul>
      <% har_file.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :har_file_name %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_area :description, id: :har_file_description %>
  </div>

  <div class="field">
    <%= form.label :content %>
    <%= form.file_field :content, id: :har_file_content %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/har_files/edit.html.erb
<h1>Editing Har File</h1>

<%= render 'form', har_file: @har_file %>

<%= link_to 'Show', @har_file %> |
<%= link_to 'Back', har_files_path %>

app/views/har_files/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Har Files</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Description</th>
      <th>Content</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @har_files.each do |har_file| %>
      <tr>
        <td><%= har_file.name %></td>
        <td><%= har_file.description %></td>
        <td><%= har_file.content %></td>
        <td><%= link_to 'Show', har_file %></td>
        <td><%= link_to 'Edit', edit_har_file_path(har_file) %></td>
        <td><%= link_to 'Destroy', har_file, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Har File', new_har_file_path %>

app/views/har_files/new.html.erb
<h1>New Har File</h1>

<%= render 'form', har_file: @har_file %>

<%= link_to 'Back', har_files_path %>

app/views/har_files/show.html.erb
<p id="notice"><%= notice %></p>

<p id="name">
  <strong>Name:</strong>
  <%= @har_file.name %>
</p>

<p id="description">
  <strong>Description:</strong>
  <%= @har_file.description %>
</p>

<p id="content">
  <strong>Content:</strong>
  <%= @har_file.content %>
</p>
<%= retrieve_file_content(@har_file.content.current_path) %>
<%= link_to 'Edit', edit_har_file_path(@har_file) %> |
<%= link_to 'Back', har_files_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>HarApp</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/requests/index.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Back', har_file_url(id: @har_file_id)%>

<h1>Requests</h1>

<table>
  <thead>
    <tr>
      <th>Index</th>
      <th>Method</th>
      <th>Url</th>
      <th>Har file</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @requests.each do |request| %>
      <tr>
        <td><%= request.index %></td>
        <td><%= request.method %></td>
        <td><%= request.uri %></td>
        <td><%= link_to 'Show', har_file_request_by_index_url(index: request.index) %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

app/views/requests/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Index:</strong>
  <%= @request.index %>
</p>

<p>
  <strong>Method:</strong>
  <%= @request.method %>
</p>

<p>
  <strong>Url:</strong>
  <%= @request.uri %>
</p>

<p>
  <strong>Har file:</strong>
  <%= @request.har_file %>
</p>
<%= link_to 'Back', har_file_requests_url(id: @request.har_file_id) %>